package com.cico.nest.lcdp.boot.core.system.service.dept;


import com.cico.nest.lcdp.boot.core.system.controller.admin.dept.vo.dept.DeptListReqVO;
import com.cico.nest.lcdp.boot.core.system.controller.admin.dept.vo.dept.DeptRespVO;
import com.cico.nest.lcdp.boot.core.system.controller.admin.dept.vo.dept.DeptSaveReqV2VO;
import com.cico.nest.lcdp.boot.core.system.controller.admin.dept.vo.dept.DeptSaveReqVO;
import com.cico.nest.lcdp.boot.core.system.dal.dataobject.dept.DeptDO;
import com.cico.nest.lcdp.framework.common.util.collection.CollectionUtils;
import jakarta.validation.Valid;

import java.util.Collection;
import java.util.List;
import java.util.Map;
import java.util.Set;

/**
 * 部门 Service 接口
 *
 * @author zws
 */
public interface DeptService {

    /**
     * 创建部门
     *
     * @param createReqVO 部门信息
     * @return 部门编号
     */
    String createDept(DeptSaveReqVO createReqVO);

    /**
     * 更新部门
     *
     * @param updateReqVO 部门信息
     */
    void updateDept(DeptSaveReqVO updateReqVO);

    /**
     * 删除部门
     *
     * @param id 部门编号
     */
    void deleteDept(String id);

    /**
     * 获得部门信息
     *
     * @param id 部门编号
     * @return 部门信息
     */
    DeptDO getDept(String id);

    /**
     * 获得部门信息数组
     *
     * @param ids 部门编号数组
     * @return 部门信息数组
     */
    List<DeptDO> getDeptList(Collection<String> ids);

    /**
     * 获得部门信息数组
     *
     * @param deptNames 部门名称数组
     * @return 部门信息数组
     */
    List<DeptDO> listDeptByNames(Collection<String> deptNames);

    /**
     * 筛选部门列表
     *
     * @param reqVO 筛选条件请求 VO
     * @return 部门列表
     */
    List<DeptDO> getDeptList(DeptListReqVO reqVO);

    /**
     * 获得指定编号的部门 Map
     *
     * @param ids 部门编号数组
     * @return 部门 Map
     */
    default Map<String, DeptDO> getDeptMap(Collection<String> ids) {
        List<DeptDO> list = getDeptList(ids);
        return CollectionUtils.convertMap(list, DeptDO::getId);
    }

    /**
     * 获得指定部门的所有子部门
     *
     * @param id 部门编号
     * @return 子部门列表
     */
    List<DeptDO> getChildDeptList(String id);

    /**
     * 获得所有子部门，从缓存中
     *
     * @param id 父部门编号
     * @return 子部门列表
     */
    Set<String> getChildDeptIdListFromCache(String id);

    /**
     * 校验部门们是否有效。如下情况，视为无效：
     * 1. 部门编号不存在
     * 2. 部门被禁用
     *
     * @param ids 角色编号数组
     */
    void validateDeptList(Collection<String> ids);

    /**
     * 创建组织
     *
     * @param createReqVO 部门信息
     * @return 部门编号
     */
    String createDeptV2(DeptSaveReqV2VO createReqVO);

    /**
     * 更新部门
     *
     * @param updateReqVO 部门信息
     */
    void updateDeptV2(@Valid DeptSaveReqV2VO updateReqVO);

    /**
     * 批量删除组织（只允许不存在子组织时候可以删除）
     * @param ids
     */
    void deleteDepts(List<String> ids);
    /**
     * 筛选部门列表v2
     *
     * @param reqVO 筛选条件请求 VO
     * @return 部门列表
     */
    List<DeptRespVO> getDeptListV2(DeptListReqVO reqVO);

    /**
     * 获取关联子部门列表
     * @param deptId 部门id
     * @return
     */
    List<DeptRespVO> getSubDeptList(String deptId);
}
